require "util"
require "exceptions"
--here we'll check all the trees in the game and will generate their transparent copies

transparent_trees={}--here we'll put our new trees
for _,tree in pairs(data.raw.tree) do--the iteration
    if not (exceptions.names[tree.name]) then
        local t_tree=table.deepcopy(tree)--copying
        t_tree.name="trnsp-#"..tree.name.."#"--give copy a name with specific format
        t_tree.selection_box={{0,0},{0,0}}--make tree not interfere with selection
        t_tree.autoplace=nil--disable it from being placed automatically
        --making copy transparent
        --there are two kinds of trees, 
        --first is defined as any other entity, its modification will be simple
        if t_tree.pictures then
            for _,picture in ipairs(t_tree.pictures) do
            --most entities allow tint to be placed in the same table which holds filename of a picture
            --this tint will be used to alter color balance of the picture
                picture.tint={r=1,g=1,b=1,a=.1}
            end
        end
        --second one is generated procedurally and its modification is slightly more convoulted
        --but the idea is the same: put tint table to where "filename" is held
        if t_tree.variations then
            for _,variation in pairs(t_tree.variations) do
                if variation.leaves then 
                    variation.leaves.tint={r=1,g=1,b=1,a=.1}
                end
                if variation.trunk then 
                    variation.trunk.tint={r=1,g=1,b=1,a=.1}
                end
            end
        end
        --store the resulting entity in table
        table.insert(transparent_trees,t_tree)
    end
end
--after all trees are altered push the data into game
data:extend(transparent_trees)
